## casablanca 2.2.0

=== Build_android/Makefile ===
# Note: we require android ndk r9d available from
# https://dl.google.com/android/ndk/android-ndk-r9d-linux-x86_64.tar.bz2
# https://dl.google.com/android/ndk/android-ndk-r9d-windows-x86_64.zip

# Variables setup

NDK:=$(realpath ${ANDROID_NDK})

ifndef ANDROID_NDK
define check-ndk
	$(error ANDROID_NDK is undefined);
endef
else
ifeq '${NDK}' ''
define check-ndk
	$(error ANDROID_NDK does not point to a directory);
endef
else
define check-ndk
endef
endif
endif

SRC_DIR:=$(shell pwd)

all: build/CMakeCache.txt

# --------
# Openssl
# --------

# This steps are based on the github project openssl1.0.1g-android
# https://github.com/aluvalasuman/openssl1.0.1g-android

openssl/openssl-1.0.1h.tar.gz:
	cd openssl && \
	wget http://www.openssl.org/source/openssl-1.0.1h.tar.gz

openssl/openssl-1.0.1h/Configure: openssl/openssl-1.0.1h.tar.gz
	cd openssl && \
	rm -rf openssl-1.0.1h && \
	tar xzf openssl-1.0.1h.tar.gz
	touch $@

openssl/r9d-9-armeabiv7/lib/libssl.a: openssl/openssl-1.0.1h/Configure
	$(call check-ndk)
	cd openssl/openssl-1.0.1h && \
	export ANDROID_NDK="${NDK}" && \
	. ../android_configure_armeabiv7.sh && \
	./Configure android no-shared --prefix=${SRC_DIR}/openssl/r9d-9-armeabiv7 --openssldir=openssl && \
	$(MAKE) all install_sw

# --------
# libiconv
# --------

# This steps are based on the blog post
# http://danilogiulianelli.blogspot.com/2012/12/how-to-cross-compile-libiconv-for.html

libiconv/libiconv-1.13.1.tar.gz:
	cd libiconv && \
	wget http://ftp.gnu.org/pub/gnu/libiconv/libiconv-1.13.1.tar.gz

libiconv/iconv-patched-stamp: libiconv/libiconv-1.13.1.tar.gz
	cd libiconv && \
	rm -rf libiconv-1.13.1 && \
	tar xzf libiconv-1.13.1.tar.gz && \
	patch -b -p0 < ./libiconv.patch && \
	touch iconv-patched-stamp

libiconv/libiconv-1.13.1/include/iconv.h: libiconv/iconv-patched-stamp
	cd libiconv/libiconv-1.13.1 && \
	./configure

libiconv/libs/armeabi-v7a/libiconv.so: libiconv/libiconv-1.13.1/include/iconv.h
	$(call check-ndk)
	cd libiconv/jni && \
	${ANDROID_NDK}/ndk-build

libiconv/r9d-9-armeabiv7a/include/iconv.h: libiconv/libiconv-1.13.1/include/iconv.h
	mkdir -p libiconv/r9d-9-armeabiv7a/include
	cp $< $@

libiconv/r9d-9-armeabiv7a/lib/libiconv.so: libiconv/libs/armeabi-v7a/libiconv.so
	mkdir -p libiconv/r9d-9-armeabiv7a/lib
	cp $< $@

# libiconv: libiconv/r9d-9-armeabiv7a/lib/libiconv.so libiconv/r9d-9-armeabiv7a/include/iconv.h

# -----
# Boost
# -----
# Uses the script from MysticTreeGames

Boost-for-Android/.git:
	git clone https://github.com/MysticTreeGames/Boost-for-Android.git

Boost-for-Android/patched-stamp: Boost-for-Android/.git boost-for-android.patch
	cd Boost-for-Android && \
	git checkout 8075d96cc9ef42d5c52d233b8ee42cb8421a2818 && \
	git checkout -- . && \
	patch -p1 < ../boost-for-android.patch && \
	touch patched-stamp

Boost-for-Android/build/lib/libboost_locale-gcc-mt-1_55.a: \
		libiconv/r9d-9-armeabiv7a/lib/libiconv.so \
		libiconv/r9d-9-armeabiv7a/include/iconv.h \
		Boost-for-Android/patched-stamp
	$(call check-ndk)
	cd Boost-for-Android && \
	./build-android.sh "${NDK}"

# -------------
# android-cmake
# -------------

android-cmake/android.toolchain.cmake:
	git clone https://github.com/taka-no-me/android-cmake.git

# ----------
# casablanca
# ----------

build/CMakeCache.txt: \
		android-cmake/android.toolchain.cmake \
		Boost-for-Android/build/lib/libboost_locale-gcc-mt-1_55.a \
		openssl/r9d-9-armeabiv7/lib/libssl.a \
		../Release/CMakeLists.txt
	$(call check-ndk)
	mkdir -p build
	cd build && \
	cmake ../../Release/ \
	-DCMAKE_TOOLCHAIN_FILE=../android-cmake/android.toolchain.cmake \
	-DANDROID_ABI=armeabi-v7a \
	-DANDROID_TOOLCHAIN_NAME=arm-linux-androideabi-4.8 \
	-DANDROID_STL=none \
	-DANDROID_STL_FORCE_FEATURES=ON \
	-DANDROID_NDK=${ANDROID_NDK} \
	-DANDROID_NATIVE_API_LEVEL=android-9 \
	-DANDROID_GOLD_LINKER=OFF \
	-DCMAKE_BUILD_TYPE=Debug

=== Build_iOS/CMakeLists.txt ===
project(casablanca-ios NONE)
cmake_minimum_required(VERSION 2.6)

set(TOOLCHAIN_FILE "${CMAKE_CURRENT_SOURCE_DIR}/ios-cmake/toolchain/iOS.cmake")

set(SIM_BINARY_DIR "${CMAKE_CURRENT_BINARY_DIR}/build.i386" CACHE INTERNAL "")
set(SIM_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../Release" CACHE INTERNAL "")

set(ARM_BINARY_DIR "${CMAKE_CURRENT_BINARY_DIR}/build.arm" CACHE INTERNAL "")
set(ARM_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../Release" CACHE INTERNAL "")

file(MAKE_DIRECTORY ${SIM_BINARY_DIR})
execute_process(WORKING_DIRECTORY ${SIM_BINARY_DIR}
  COMMAND ${CMAKE_COMMAND}
    -GXcode
    -DCMAKE_TOOLCHAIN_FILE=${TOOLCHAIN_FILE}
    -DIOS_PLATFORM=SIMULATOR
    -DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}
    "${SIM_SOURCE_DIR}"
    )

file(MAKE_DIRECTORY ${ARM_BINARY_DIR})
execute_process(WORKING_DIRECTORY ${ARM_BINARY_DIR}
  COMMAND ${CMAKE_COMMAND}
    -GXcode
    -DCMAKE_TOOLCHAIN_FILE=${TOOLCHAIN_FILE}
    -DIOS_PLATFORM=OS
    "-DCMAKE_OSX_ARCHITECTURES=armv7s;armv7;arm64"
    -DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}
    "${ARM_SOURCE_DIR}"
    )


## Simulator version
add_custom_target(sim
  COMMAND ${CMAKE_COMMAND}
    --build ${SIM_BINARY_DIR}
    --target cpprest
    --config ${CMAKE_BUILD_TYPE}
  COMMENT "Building for i386 (simulator)"
  VERBATIM
)

## ARM version
add_custom_target(arm
  COMMAND ${CMAKE_COMMAND}
    --build ${ARM_BINARY_DIR}
    --target cpprest
    --config ${CMAKE_BUILD_TYPE}
  COMMENT "Building for armv7, armv7s, arm64"
  VERBATIM
)

set(LIB_CPPREST libcpprest.a)
add_custom_command(
  OUTPUT ${LIB_CPPREST}
  COMMAND lipo -create
    -output "${CMAKE_CURRENT_BINARY_DIR}/${LIB_CPPREST}"
    ${SIM_BINARY_DIR}/Binaries/${CMAKE_BUILD_TYPE}/${LIB_CPPREST}
    ${ARM_BINARY_DIR}/Binaries/${CMAKE_BUILD_TYPE}/${LIB_CPPREST}
  DEPENDS
    sim
    arm
    "${SIM_BINARY_DIR}/Binaries/${CMAKE_BUILD_TYPE}/${LIB_CPPREST}"
    "${ARM_BINARY_DIR}/Binaries/${CMAKE_BUILD_TYPE}/${LIB_CPPREST}"
  VERBATIM
)

add_custom_target(cpprest ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/${LIB_CPPREST})

=== Release/CMakeLists.txt ===
set(CMAKE_LEGACY_CYGWIN_WIN32 0)
cmake_minimum_required(VERSION 2.6)
project(casablanca)

enable_testing()

set(WARNINGS)
set(ANDROID_STL_FLAGS)

# Platform (not compiler) specific settings
if(IOS)
  set(IOS_SOURCE_DIR "${CMAKE_SOURCE_DIR}/../Build_iOS")
  set(Boost_FRAMEWORK "-F ${IOS_SOURCE_DIR} -framework boost")
  set(Boost_INCLUDE_DIR "${IOS_SOURCE_DIR}/boost.framework/Headers")

  set(OPENSSL_FOUND 1)
  set(OPENSSL_INCLUDE_DIR "${IOS_SOURCE_DIR}/openssl/include")
  set(OPENSSL_LIBRARIES
    "${IOS_SOURCE_DIR}/openssl/lib/libcrypto.a"
    "${IOS_SOURCE_DIR}/openssl/lib/libssl.a"
    )

  # The cxx_flags must be set here, because the ios-cmake toolchain file unfortunately sets "-headerpad_max_install_names" which is not a valid clang flag.
  set(CMAKE_CXX_FLAGS "-fvisibility=hidden -fvisibility-inlines-hidden")

  set(BUILD_SHARED_LIBS OFF)
  set(BUILD_SAMPLES OFF)
  option(BUILD_TESTS "Build tests." ON)
elseif(ANDROID)
  set(ANDROID_SOURCE_DIR "${CMAKE_SOURCE_DIR}/../Build_android")

  set(Boost_COMPILER "-gcc")
  set(Boost_USE_STATIC_LIBS ON)
  set(BOOST_ROOT "${CMAKE_BINARY_DIR}/../Boost-for-Android/build")
  set(BOOST_LIBRARYDIR "${CMAKE_BINARY_DIR}/../Boost-for-Android/build/lib")
  find_host_package(Boost 1.55 EXACT REQUIRED COMPONENTS random system thread locale filesystem chrono atomic)

  find_package(Threads REQUIRED)
  set(OPENSSL_FOUND 1)
  set(OPENSSL_INCLUDE_DIR "${CMAKE_BINARY_DIR}/../openssl/r9d-9-armeabiv7/include")
  set(OPENSSL_LIBRARIES
    "${CMAKE_BINARY_DIR}/../openssl/r9d-9-armeabiv7/lib/libssl.a"
    "${CMAKE_BINARY_DIR}/../openssl/r9d-9-armeabiv7/lib/libcrypto.a"
    )
  set(LIBCXX_STL "${ANDROID_NDK}/sources/cxx-stl/gnu-libstdc++/4.8/libs/armeabi-v7a/libgnustl_shared.so")
  set(ANDROID_STL_FLAGS
    gcc
    ${LIBCXX_STL}
    atomic
    c
    m
    dl
    -nodefaultlibs
    )

  set(BUILD_SHARED_LIBS ON)
  set(BUILD_SAMPLES OFF)
  option(BUILD_TESTS "Build tests." ON)
elseif(UNIX) # This includes OSX
  find_package(Boost REQUIRED COMPONENTS random chrono system thread locale regex filesystem)
  find_package(Threads REQUIRED)
  find_package(OpenSSL REQUIRED)

  option(BUILD_SHARED_LIBS "Build shared Libraries." ON)
  option(BUILD_TESTS "Build tests." ON)
  option(BUILD_SAMPLES "Build samples." ON)
elseif(WIN32)
  option(BUILD_SHARED_LIBS "Build shared Libraries." ON)
  option(BUILD_TESTS "Build tests." ON)
  option(BUILD_SAMPLES "Build samples." ON)

  add_definitions(-DUNICODE)

  if(NOT BUILD_SHARED_LIBS)
    # This causes cmake to not link the test libraries separately, but instead hold onto their object files.
    set(TEST_LIBRARY_TARGET_TYPE OBJECT)
  endif()

  set(LIB lib)
else()
  message(FATAL_ERROR "-- Unsupported Build Platform.")
endif()

# Compiler (not platform) specific settings
if(ANDROID)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -fno-strict-aliasing")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-pedantic")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-attributes -Wno-pointer-arith")
  include_directories(
    "${ANDROID_NDK}/sources/cxx-stl/gnu-libstdc++/4.8/include"
    "${ANDROID_NDK}/sources/cxx-stl/gnu-libstdc++/4.8/libs/armeabi-v7a/include"
    "${ANDROID_NDK}/sources/cxx-stl/gnu-libstdc++/4.8/include/backward"
    )
elseif(("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang") OR IOS)
  message("-- Setting clang options")

  set(WARNINGS "-Wall -Wextra -Wcast-qual -Wconversion -Wformat=2 -Winit-self -Winvalid-pch -Wmissing-format-attribute -Wmissing-include-dirs -Wpacked -Wredundant-decls")
  set(OSX_SUPPRESSIONS "-Wno-overloaded-virtual -Wno-sign-conversion -Wno-deprecated -Wno-unknown-pragmas -Wno-reorder -Wno-char-subscripts -Wno-switch -Wno-unused-parameter -Wno-unused-variable -Wno-deprecated -Wno-unused-value -Wno-unknown-warning-option -Wno-return-type-c-linkage -Wno-unused-function -Wno-sign-compare -Wno-shorten-64-to-32 -Wno-reorder")
  set(WARNINGS "${WARNINGS} ${OSX_SUPPRESSIONS}")

  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++ -Wno-return-type-c-linkage -Wno-unneeded-internal-declaration")
  set(CMAKE_XCODE_ATTRIBUTE_CLANG_CXX_LIBRARY "libc++")
  set(CMAKE_XCODE_ATTRIBUTE_CLANG_CXX_LANGUAGE_STANDARD "c++11")

  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -fno-strict-aliasing")
  set(STRICT_CXX_FLAGS ${WARNINGS} "-Werror -pedantic")
elseif("${CMAKE_CXX_COMPILER_ID}" MATCHES "GNU")
  message("-- Setting gcc options")

  set(WARNINGS "-Wall -Wextra -Wunused-parameter -Wcast-align -Wcast-qual -Wconversion -Wformat=2 -Winit-self -Winvalid-pch -Wmissing-format-attribute -Wmissing-include-dirs -Wpacked -Wredundant-decls -Wunreachable-code")
  set(LINUX_SUPPRESSIONS "-Wno-deprecated -Wno-unknown-pragmas -Wno-reorder -Wno-unused-function -Wno-char-subscripts -Wno-switch -Wno-unused-but-set-parameter -Wno-unused-value -Wno-unused-local-typedefs")

  set(WARNINGS "${WARNINGS} ${LINUX_SUPPRESSIONS}")
  set(LD_FLAGS "${LD_FLAGS} -Wl,-z,defs")

  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -fno-strict-aliasing")
  set(STRICT_CXX_FLAGS ${WARNINGS} "-Werror -pedantic")
else()
  message("-- Unknown compiler, success is doubtful.")
endif()

# Reconfigure final output directory
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/Binaries)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/Binaries)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/Binaries)

# These settings can be used by the test targets
set(Casablanca_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include)
set(Casablanca_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/include ${Boost_INCLUDE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/libs/websocketpp)

set(Casablanca_LIBRARY ${LIB}cpprest)
set(Casablanca_LIBRARIES ${Casablanca_LIBRARY} ${Boost_LIBRARIES} ${Boost_FRAMEWORK})

# Everything in the project needs access to the casablanca include directories
include_directories(${Casablanca_INCLUDE_DIRS})

# Finally, the tests all use the same style declaration to build themselves, so we use a function
function(add_casablanca_test NAME SOURCES_VAR)
  add_library(${NAME} ${TEST_LIBRARY_TARGET_TYPE} ${${SOURCES_VAR}})
  message("-- Added test library ${NAME}")
  if (NOT TEST_LIBRARY_TARGET_TYPE STREQUAL "OBJECT")
    target_link_libraries(${NAME}
      ${LIB}httptest_utilities
      ${LIB}common_utilities
      ${LIB}unittestpp
      ${Casablanca_LIBRARIES}
      ${ANDROID_STL_FLAGS}
      )
    if (BUILD_SHARED_LIBS)
      add_test(NAME ${NAME}
        WORKING_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
        COMMAND test_runner lib${NAME}${CMAKE_SHARED_LIBRARY_SUFFIX}
        )
    endif()
  endif()
endfunction()

add_subdirectory(src)

if(BUILD_TESTS)
  add_subdirectory(tests)
endif()

if(BUILD_SAMPLES)
  add_subdirectory(samples)
endif()

=== Release/src/CMakeLists.txt ===
include_directories(../include pch ${Boost_INCLUDE_DIR} ${OPENSSL_INCLUDE_DIR})

# THE ORDER OF FILES IS VERY /VERY/ IMPORTANT
if(UNIX)
  set(SOURCES
    streams/linux/fileio_linux.cpp
    json/json.cpp
    json/json_parsing.cpp
    json/json_serialization.cpp
    utilities/asyncrt_utils.cpp
    pplx/pplx.cpp
    pplx/threadpool.cpp
    uri/uri.cpp
    uri/uri_builder.cpp
    uri/uri_parser.cpp
    http/common/http_msg.cpp
    http/common/http_helpers.cpp
    http/client/http_msg_client.cpp
    http/client/http_linux.cpp
    http/client/x509_cert_utilities.cpp
    http/listener/http_linux_server.cpp
    http/listener/http_listener.cpp
    http/listener/http_msg_listen.cpp
    http/listener/http_server_api.cpp
    http/oauth/oauth1.cpp
    http/oauth/oauth2.cpp
    websockets/client/ws_msg.cpp
    websockets/client/ws_client.cpp
    utilities/base64.cpp
    )
  if(APPLE)
    set(SOURCES ${SOURCES} pplx/apple/pplxapple.cpp)
    find_library(COREFOUNDATION CoreFoundation "/")
    find_library(SECURITY Security "/")
    set(EXTRALINKS ${COREFOUNDATION} ${SECURITY})
  else()
    set(SOURCES ${SOURCES} pplx/linux/pplxlinux.cpp)
  endif()

  if(ANDROID)
    set(EXTRALINKS "${CMAKE_BINARY_DIR}/../libiconv/r9d-9-armeabiv7a/lib/libiconv.so")
  endif()
elseif(WIN32)
  set(SOURCES
    json/json.cpp
    json/json_parsing.cpp
    json/json_serialization.cpp
    utilities/asyncrt_utils.cpp
    uri/uri.cpp
    uri/uri_builder.cpp
    uri/uri_parser.cpp
    http/common/http_msg.cpp
    http/common/http_helpers.cpp
    http/client/http_msg_client.cpp
    http/client/x509_cert_utilities.cpp
    http/listener/http_listener.cpp
    http/listener/http_msg_listen.cpp
    http/listener/http_server_api.cpp
    websockets/client/ws_msg.cpp
    websockets/client/ws_client.cpp
    utilities/base64.cpp
    http/client/http_win7.cpp
    http/listener/http_windows_server.cpp
    http/oauth/oauth1.cpp
    streams/windows/fileio.cpp
    streams/windows/ioscheduler.cpp
    utilities/dllmain.cpp
    )
  add_definitions(
    -D_ASYNCRT_EXPORT
    -D_PPLX_EXPORT
    -D_MBCS
    -D_USRDLL
    )
  set(EXTRALINKS Httpapi.lib Winhttp.dll)
endif()

set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${WARNINGS} -Werror -pedantic")

add_library(${Casablanca_LIBRARY} ${SOURCES})

target_link_libraries(${Casablanca_LIBRARY}
  ${CMAKE_THREAD_LIBS_INIT}
  ${Boost_SYSTEM_LIBRARY}
  ${Boost_THREAD_LIBRARY}
  ${Boost_ATOMIC_LIBRARY}
  ${Boost_CHRONO_LIBRARY}
  ${Boost_LOCALE_LIBRARY}
  ${Boost_RANDOM_LIBRARY}
  ${EXTRALINKS}
  ${Boost_FRAMEWORK}
  ${OPENSSL_LIBRARIES}
  ${COREFOUNDATION}
  ${ANDROID_STL_FLAGS}
  )

# Portions specific to cpprest binary versioning.
set (CPPREST_VERSION_MAJOR 2)
set (CPPREST_VERSION_MINOR 2)
set (CPPREST_VERSION_REVISION 0)

if(WIN32)
  set_target_properties(${Casablanca_LIBRARY} PROPERTIES
    OUTPUT_NAME "${Casablanca_LIBRARY}_${CPPREST_VERSION_MAJOR}_${CPPREST_VERSION_MINOR}")
elseif(ANDROID)
  # Do not use SOVERSION on android. It is completely unsupported (and causes problems).
  # Perhaps revisit in the future? (NDK r9d, 8/7/14)
else()
  set_target_properties(${Casablanca_LIBRARY} PROPERTIES
    SOVERSION ${CPPREST_VERSION_MAJOR}.${CPPREST_VERSION_MINOR})
endif()

=== Release/tests/CMakeLists.txt ===
set(UnitTestpp_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/Common/UnitTestpp)
set(Utilities_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/Common/utilities/include)

include_directories (${UnitTestpp_INCLUDE_DIR} ${Utilities_INCLUDE_DIR})

add_subdirectory(Common)
add_subdirectory(Functional)

=== Release/tests/Common/TestRunner/CMakeLists.txt ===
include_directories(${Casablanca_INCLUDE_DIR}
  ../UnitTestpp
  ${Boost_INCLUDE_DIR}
  )

set(TR_SOURCES
  test_runner.cpp
  test_module_loader.cpp
  )

add_definitions(-DDESKTOP_TEST_RUNNER)

if(NOT IOS)
  if(BUILD_SHARED_LIBS)
    add_executable(test_runner
      test_runner.cpp
      test_module_loader.cpp
      )

    target_link_libraries(test_runner
      ${Boost_FRAMEWORK}
      ${Boost_SYSTEM_LIBRARY}
      ${Boost_FILESYSTEM_LIBRARY}
      ${LIB}unittestpp
      ${CMAKE_DL_LIBS}
      )
  else()
    if (APPLE)
      add_executable(test_runner
        test_runner.cpp
        test_module_loader.cpp
        )

      target_link_libraries(test_runner
        ${Boost_FRAMEWORK}
        ${Boost_SYSTEM_LIBRARY}
        ${Boost_FILESYSTEM_LIBRARY}
        ${LIB}unittestpp
        ${CMAKE_DL_LIBS}
        -Wl,-force_load
        ${LIB}httpclient_test

        -Wl,-force_load
        ${LIB}json_test

        -Wl,-force_load
        ${LIB}uri_test

        -Wl,-force_load
        ${LIB}pplx_test

        -Wl,-force_load
        ${LIB}httplistener_test

        -Wl,-force_load
        ${LIB}streams_test

        -Wl,-force_load
        ${LIB}utils_test
        )
    elseif(UNIX)
      add_executable(test_runner
        test_runner.cpp
        test_module_loader.cpp
        )

      target_link_libraries(test_runner
        ${Boost_FRAMEWORK}
        ${Boost_SYSTEM_LIBRARY}
        ${Boost_FILESYSTEM_LIBRARY}
        ${LIB}unittestpp
        ${CMAKE_DL_LIBS}
        -Wl,--whole-archive
        ${LIB}httpclient_test
        ${LIB}json_test
        ${LIB}uri_test
        ${LIB}pplx_test
        ${LIB}httplistener_test
        ${LIB}streams_test
        ${LIB}utils_test
        -Wl,--no-whole-archive
        )
    else()
      # In order to achieve --whole-archive on windows, we link all the test files into the test_runner directly
      # This means that the tests themselves must be created as "OBJECT" libraries
      add_executable(test_runner
        test_runner.cpp
        test_module_loader.cpp
        $<TARGET_OBJECTS:${LIB}httpclient_test>
        $<TARGET_OBJECTS:${LIB}json_test>
        $<TARGET_OBJECTS:${LIB}uri_test>
        $<TARGET_OBJECTS:${LIB}pplx_test>
        $<TARGET_OBJECTS:${LIB}httplistener_test>
        $<TARGET_OBJECTS:${LIB}streams_test>
        $<TARGET_OBJECTS:${LIB}utils_test>
        )
      target_link_libraries(test_runner
        ${LIB}unittestpp
        ${CMAKE_DL_LIBS}
        )
    endif()
  endif()

  add_custom_target(run_tests ALL DEPENDS run_tests.sh)
  add_custom_command(
    OUTPUT run_tests.sh
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/run_tests.sh $<TARGET_FILE_DIR:test_runner>
    DEPENDS run_tests.sh
    )
endif()

=== Release/tests/Common/utilities/CMakeLists.txt ===
include_directories(include)

if(UNIX)
  set(CXX_FLAGS "${CXX_FLAGS} -include ../../../include/compat/linux_compat.h")
elseif(WIN32)
  add_definitions(-DCOMMONUTILITIES_EXPORTS)
endif()

add_library(${LIB}common_utilities
  os_utilities.cpp
  stdafx.cpp
  )

target_link_libraries(${LIB}common_utilities
  ${Casablanca_LIBRARY}
  ${LIB}unittestpp
  ${Boost_SYSTEM_LIBRARY}
  ${Boost_THREAD_LIBRARY}
  )

=== Release/tests/Functional/pplx/pplx_test/CMakeLists.txt ===
set(SOURCES
  pplx_op_test.cpp
  pplx_task_options.cpp
  pplxtask_tests.cpp
  pplx_scheduler.cpp
  stdafx.cpp
)

add_casablanca_test(${LIB}pplx_test SOURCES)

=== debian/changelog ===
casablanca (2.2.0-1) unstable; urgency=low

  * Initial release. (Closes: #722275)

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Mon, 03 Nov 2014 14:33:57 +0100

=== debian/control ===
Source: casablanca
Section: libs
Priority: extra
Maintainer: Gianfranco Costamagna <costamagnagianfranco@yahoo.it>
Build-Depends: cmake,
               debhelper (>=9),
               libboost-chrono-dev,
               libboost-filesystem-dev,
               libboost-locale-dev,
               libboost-random-dev,
               libboost-regex-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libssl-dev,
               libwebsocketpp-dev
Build-Depends-Indep: doxygen
Standards-Version: 3.9.6
Homepage: https://casablanca.codeplex.com/
Vcs-Git: git://anonscm.debian.org/collab-maint/casablanca.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/casablanca.git

Package: libcpprest2.2
Provides: libcpprest
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Shared library for Casablanca
 The C++ REST SDK (codename "Casablanca") is a Microsoft project for cloud-based
 client-server communication in native code using a modern asynchronous C++ API
 design. This project allows C++ developers to take advantage of the radical
 shift in software architecture that cloud computing represents.
  * Support for accessing REST services from native code on Linux, Windows
    Vista, Windows 7, and Windows 8 by providing asynchronous C++ bindings
    to HTTP, JSON, and URIs
  * Implementation of Asynchronous Streams and Stream Buffers
  * A consistent and powerful model for composing asynchronous operations based
    on C++ 11 features
  * A set of samples and reference documentation
  * New experimental features such as HTTP Listener library and support for
  Windows Phone 8 and Windows XP.
 .
 This package contains the library files.

Package: libcpprest-dev
Section: libdevel
Architecture: any
Depends: libcpprest2.2 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Development files for Casablanca
 The C++ REST SDK (codename "Casablanca") is a Microsoft project for cloud-based
 client-server communication in native code using a modern asynchronous C++ API
 design. This project allows C++ developers to take advantage of the radical
 shift in software architecture that cloud computing represents.
  * Support for accessing REST services from native code on Linux, Windows
    Vista, Windows 7, and Windows 8 by providing asynchronous C++ bindings
    to HTTP, JSON, and URIs
  * Implementation of Asynchronous Streams and Stream Buffers
  * A consistent and powerful model for composing asynchronous operations based
    on C++ 11 features
  * A set of samples and reference documentation
  * New experimental features such as HTTP Listener library and support for
  Windows Phone 8 and Windows XP.
 .
 This package contains header files that are needed to develop and
 compile applications which utilizes the Casablanca framework.

Package: libcpprest-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Reference manual for Casablanca
 The C++ REST SDK (codename "Casablanca") is a Microsoft project for cloud-based
 client-server communication in native code using a modern asynchronous C++ API
 design. This project allows C++ developers to take advantage of the radical
 shift in software architecture that cloud computing represents.
  * Support for accessing REST services from native code on Linux, Windows
    Vista, Windows 7, and Windows 8 by providing asynchronous C++ bindings
    to HTTP, JSON, and URIs
  * Implementation of Asynchronous Streams and Stream Buffers
  * A consistent and powerful model for composing asynchronous operations based
    on C++ 11 features
  * A set of samples and reference documentation
  * New experimental features such as HTTP Listener library and support for
  Windows Phone 8 and Windows XP.
 .
 This package contains the common documentation.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
%:
	dh $@ --parallel --sourcedirectory=Release

override_dh_auto_clean:
	dh_auto_clean
	rm -rf html latex

override_dh_auto_build-indep:
	doxygen Release/public_apis_doxyfile

override_dh_install-indep:
	dh_install -plibcpprest-doc html/* usr/share/doc/libcpprest-doc/html

override_dh_install:
	dh_install -plibcpprest-dev Release/include                  usr/
	dh_install -plibcpprest-dev obj-*/Binaries/libcpprest.so     usr/lib/$(DEB_HOST_MULTIARCH)
	dh_install -plibcpprest2.2  obj-*/Binaries/libcpprest.so.2.2 usr/lib/$(DEB_HOST_MULTIARCH)

## casablanca 2.4.0

=== debian/changelog ===
casablanca (2.4.0-2) unstable; urgency=medium

  * Make the package Multi-Arch: same

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Wed, 11 Mar 2015 20:29:04 +0100

casablanca (2.4.0-1) unstable; urgency=medium

  * New upstream release, bump SONAME to 2.4.
    - remove patch fix-ftbfs, addressed upstream.
    - refresh disable-outside-tests and disable ssl_test, requiring
      internet connection.
    - Update copyright file.

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Sat, 03 Jan 2015 13:52:06 +0100

=== debian/control ===
--- 
+++ 
@@ -19,9 +19,11 @@
 Vcs-Git: git://anonscm.debian.org/collab-maint/casablanca.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/casablanca.git
 
-Package: libcpprest2.2
+Package: libcpprest2.4
 Provides: libcpprest
 Architecture: any
+Multi-Arch: same
+Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Shared library for Casablanca
  The C++ REST SDK (codename "Casablanca") is a Microsoft project for cloud-based
@@ -43,7 +45,9 @@
 Package: libcpprest-dev
 Section: libdevel
 Architecture: any
-Depends: libcpprest2.2 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Depends: libcpprest2.4 (= ${binary:Version}),
+         ${misc:Depends},
+         ${shlibs:Depends}
 Description: Development files for Casablanca
  The C++ REST SDK (codename "Casablanca") is a Microsoft project for cloud-based
  client-server communication in native code using a modern asynchronous C++ API

=== debian/rules ===
--- 
+++ 
@@ -19,4 +19,4 @@
 override_dh_install:
 	dh_install -plibcpprest-dev Release/include                  usr/
 	dh_install -plibcpprest-dev obj-*/Binaries/libcpprest.so     usr/lib/$(DEB_HOST_MULTIARCH)
-	dh_install -plibcpprest2.2  obj-*/Binaries/libcpprest.so.2.2 usr/lib/$(DEB_HOST_MULTIARCH)
+	dh_install -plibcpprest2.4  obj-*/Binaries/libcpprest.so.2.4 usr/lib/$(DEB_HOST_MULTIARCH)
